from collections import deque, defaultdict


def find_guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded_warehouses = set()

    for p, h in guards:
        queue = deque([(p, 0)])
        visited = set()
        visited.add(p)

        while queue:
            current_warehouse, distance = queue.popleft()
            if distance > h:
                continue

            guarded_warehouses.add(current_warehouse)

            for neighbor in graph[current_warehouse]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    guarded_warehouses = sorted(guarded_warehouses)

    print(len(guarded_warehouses))
    if guarded_warehouses:
        print(" ".join(map(str, guarded_warehouses)))
    else:
        print()


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

find_guarded_warehouses(n, m, k, roads, guards)
